from Module import Module
from irclib import irclib
from urllib2 import urlopen
from urllib import urlencode

class GoogleTranslate(Module):
    # Class that translates text via Google Translate.
    #
    # http://code.google.com/apis/ajaxlanguage/documentation/

    def __init__(self, config, server, modlist, rehash):
        super(GoogleTranslate, self).__init__(config, server, modlist, rehash)
        modlist.append(self)

    def register_handlers(self, server):
        server.add_global_handler('pubmsg', self.on_pubmsg)
        server.add_global_handler('privmsg', self.on_privmsg)

    def do(self, connection, event, nick, userhost, replypath, what, admin_unlocked):
        whats = what.split(' ')
        if whats[0] == 'translate' and len(whats) >= 4:
            fromlang = whats[1]
            tolang = whats[2]
            text = ' '.join(whats[3:])

            langpair = '%s|%s' % (fromlang, tolang)
            gt_url = 'http://ajax.googleapis.com/ajax/services/language/translate?'
            params = urlencode( (('v', 1.0), ('q', text), ('langpair', langpair),) )
            url = gt_url + params
            content = urlopen(url).read()
            start_idx = content.find('"translatedText":"')+18
            translation = content[start_idx:]
            end_idx = translation.find('"}, "')
            translation = translation[:end_idx]

            # do some text conversion
            translation = translation.replace('\\u0026quot;', '"')
            translation = translation.replace('\\u0026amp;', '&')
            translation = translation.replace('\\u003c', '<')
            translation = translation.replace('\\u0026lt;', '<')
            translation = translation.replace('\\u003e', '>')
            translation = translation.replace('\\u0026gt;', '>')
            translation = translation.replace('\\u0026#39;', '\'')

            if replypath is None:
                return translation
            else:
                connection.privmsg(replypath, translation)

